// Functionality required by client and back end

// How often are update requests called
updateInterval = 5000;

function disableButton(button) {
    setTimeout(function() {
        $(button).attr("disabled", "disabled");
    }, 10);
}

function showPageLoader(message) {
    $(".page-loader-message").html(message);
    $(".page-loader-container").show();
}

function hidePageLoader() {
    $(".page-loader-container").hide();
}

function positionsDifferent(first, second) {
    if (first &&
        (first.lat()).toFixed(6) == (second.lat()).toFixed(6) &&
        (first.lng()).toFixed(6) == (second.lng()).toFixed(6)) {
            return false;
    }

    return true;
}

function getCity(result) {
    var components = result.address_components;
    for (var i = 0; i < components.length; i++) {
        if (components[i].types.length) {
            var t = components[i].types;

            if (t.indexOf("administrative_area_level_3") != -1) {
                return components[i].long_name;
            }
        }
    }

    return "";
}

function getSuburb(result) {
    var components = result.address_components;

    if (components.length > 2) {
        return components[2].long_name;
    }

    for (var i = 0; i < components.length; i++) {
        if (components[i].types.length) {
            var t = components[i].types;

            if (t.indexOf("sublocality") != -1) {
                return components[i].long_name;
            }
        }
    }

    return "";
}

function getPrettyAddress(result) {
    try {
        var parts = [];

        parts.push(result.address_components[0].long_name +
            " " + result.address_components[1].long_name);

        for (var i = 2; i < result.address_components.length; i++) {
            var part = result.address_components[i];

            if (i < 3) {
                parts.push(part.long_name);
            }
            else if (part.types.indexOf("locality") != -1) {
                parts.push(part.long_name);
            }
        }

        var r = parts.join(", ");
        return r;
    }
    catch (e) {
        console.log(e);
        return result.formatted_address;
    }
}

head.ready(function() {
    $(".clear-input").click(function() {
        $(this).parent().find("input").val("");
        $(this).parent().find("input").focus();
    });
});

function hideAddressBar(){
    var page = document.getElementById('page');
    var ua = navigator.userAgent;
    var iphone = (ua.indexOf('iPhone') != -1) || (ua.indexOf('iPod') != -1);
    if (ua.indexOf("OS 7") != -1) {
        // iOS 7 breaks with this trick
        iphone = false;
    }

    // Detect if this is running as a fullscreen app from the homescreen
    var fullscreen = window.navigator.standalone;
    var lastWidth = 0;

    if (iphone) {
            window.setupScroll = window.onload = function() {

              // Start out by adding the height of the location bar to the width, so that
              // we can scroll past it

                // iOS reliably returns the innerWindow size for documentElement.clientHeight
                // but window.innerHeight is sometimes the wrong value after rotating
                // the orientation
                var height = document.documentElement.clientHeight;

                // Only add extra padding to the height on iphone / ipod, since the ipad
                // browser doesn't scroll off the location bar.

                if (iphone && !fullscreen) {
                    if (ua.indexOf("CriOS") != -1) {
                        height += 1;
                    }
                    else {
                        height += 60;
                    }
                }

                page.style.height = height + 'px';

                setTimeout(scrollTo, 0, 0, 1);
            };
            (window.onresize = function() {

              var pageWidth = page.offsetWidth;
              // Android doesn't support orientation change, so check for when the width
              // changes to figure out when the orientation changes
              if (lastWidth == pageWidth) return;
              lastWidth = pageWidth;
              setupScroll();
            })();

            runAddressBarCheck(window.innerHeight);
    };
}

function permaHideInfoPopup(){
    $.cookie("info-popup-dismissed", "true", { expires: 10000 });
    $("#info-overlay-container").hide();
}

function maybeShowInfoPopup(){
    if(! $.cookie("info-popup-dismissed")){
        $("#info-overlay-container").show();
    }
}

function runAddressBarCheck(activeHeight){
    setTimeout(function(){
        if(activeHeight != window.innerHeight){
             setTimeout(function(){
                scrollTo(0,0);
                runAddressBarCheck(window.innerHeight);
             }, 5000);
        } else {
            runAddressBarCheck(activeHeight);
        }
    }, 500);
}