var onLocationSuccess = function(position) {
        console.log("got low accuracy position ");
        app.position = position;
        var lat = parseFloat(app.position.coords.latitude);
        var lng = parseFloat(app.position.coords.longitude);
        var position = new google.maps.LatLng(lat, lng);
        app.position_latlng = position;
        app.location_lat = lat;
        app.location_lng = lng;

        $("#location-error").hide();
        $("#location-lookup").hide();
        $("#reverse_geo").show();

        homepage_map(app.position);
        app.reverse_geo();
        app.map.setZoom(12);
        app.map.setCenter(position);
        app.map.panTo(position);
        update_map_marker(lat, lng);        
        fetchDriverLocations(position);
};

var onLocationError = function(error){
    console.log("error getting location");
    console.log(error.code);
    console.log(error.message);
    $("#address-display").hide();
    $("#location-lookup").hide();
    $("#location-error").show();
    //$(".address-input").show();
    app.showGpsError(onDeviceReadyLocation);
}

var onHighAccuracyLocationSuccess = function(position){
    console.log("Got high accuracy position");
    onLocationSuccess(position);
}

var onHighAccuracyLocationError = function(error){
    console.log("Error with high accuracy position");
    //try without demanding high accuracy this time
    navigator.geolocation.getCurrentPosition(onLocationSuccess, onLocationError, {});
}

function onDeviceReadyLocation() {
   console.log("device ready, getting location");
   //try high accuracy location call

   navigator.geolocation.getCurrentPosition(onHighAccuracyLocationSuccess, onHighAccuracyLocationError, {enableHighAccuracy: true, timeout: 20000});
   console.log("made getcurrentposition call");
}

function positionHoverPin(){
    console.log("map canvas height and width are:");
    console.log($("#map-canvas").height());
    console.log($("#map-canvas").width());
   $("#over_map").css('top', ($("#map-canvas").height()/2 - $("#over_map").height()) + "px");
   $("#over_map").css('left', ($("#map-canvas").width()/2 - $("#over_map").width()/2) + "px");
   $("#over_map").show();
}

function places_autocomplete(text, country){
    var apiUrl = "https://maps.googleapis.com/maps/api/place/autocomplete/json";
    var data = {
        input: text,
        sensor: "false",
        components: "country:" + country
    };

    $.ajax({
        url: apiUrl,
        data: data,
        type: "GET",
        error: function (jqXHR, textStatus, error){
            console.log("error calling places autocomplete");
            console.log(jqXHR.status);
            console.log(jqXHR.statusText);
            console.log(jqXHR.responseText);
        },
        success: function(response){
            console.log(Object.keys(response));
        }
    });
}

function homepage_map(position){
        lat = 0;
        lng = 0;
        zoom = 3;

        if (position != null){
            lat = parseFloat(position.latitude);
            lng = parseFloat(position.longitude);
            zoom = 16;
        }
        else{
            console.log("using default lat lng, position not assigned yet");
            lat = -27.747455;
            lng = 25.4236375;
        }
        var mapOptions = {
            center: new google.maps.LatLng(lat, lng),
            zoom: zoom,
            mapTypeId: google.maps.MapTypeId.ROADMAP,
            streetViewControl: false,
            mapTypeControl: false,
            zoomControl: false,
            disableDoubleClickZoom: true,
            styles: [
                {
                    featureType: "poi",
                    elementType: "labels",
                    stylers: [{
                        visibility: "off"
                    }]
                }
            ]
        };

        app.map = new google.maps.Map(document.getElementById("map-canvas"),
            mapOptions);
        
        app.setMapCenter(new google.maps.LatLng(lat, lng));

        app.map_center_changed_listener = google.maps.event.addListener(app.map, 'center_changed', function() {
            if (app.map_dragged === true)
            {
                position = app.map.getCenter();
                app.position.coords.latitude = position.lat();
                app.position.coords.longitude = position.lng();
                position_latlng = new google.maps.LatLng(position.lat(), position.lng());
                app.position_latlng = position_latlng;
                
                update_map_marker(position.lat(), position.lng());
                var positionobj = {coords: {latitude: position.lat(), longitude: position.lng()}};
                app.position = positionobj;

            }
        });

}

function update_map_marker(lat, lng){
        console.log("update map marker called");

        geocoder = new google.maps.Geocoder();
        var latlng = new google.maps.LatLng(lat, lng);

            geocoder.geocode({'latLng':latlng},
                function(results, status){
                    if (status == google.maps.GeocoderStatus.OK) {
                        if (results[0]) {
                            var components = results[0].address_components;
                            var address = results[0].formatted_address;

                            console.log("address result from rev geo: " + address);
                            app.address = address;

                            if (components.length > 2)
                                app.area = components[2].long_name;
                            else{
                                for (var i = 0; i < components.length; i++) {
                                    var t = components[i].types;
                                    if (t.indexOf("sublocality") != -1){
                                        app.area = components[i].long_name;
                                    }
                                }
                            }

                            for (var i = 0; i < components.length; i++) {
                                if (components[i].types.length) {
                                    var t = components[i].types;
                                    if (t.indexOf("administrative_area_level_3") != -1) {
                                        app.city = components[i].long_name;
                                    }
                                }
                            }

                            $("#id_address").val(address);
                            $("#address-text").text(address);
                        }
                        else{
                            console.log("no results found for geocode");
                        }
                    }
                    else{
                        console.log("geocoding failed with status: " + status);
                    }
                }
            );
}

function fetchDriverLocations(position){
        console.log("Fetch driver locations around: " + position);
        console.log(position.lat() + " " + position.lng());

        app.driverUpdateInterval = setTimeout(function() {
            fetchDriverLocations(position);
        }, 30000);

        if (!app.driverMarkers)
            app.driverMarkers = [];
        else{
            console.log("clearing driver markers to pin updated markers");
            for (var i = 0; i < app.driverMarkers.length; i++){
                app.driverMarkers[i].setMap(null);
            }
            app.driverMarkers = [];
        }

        //already in a trip, don't pin available drivers
        if (trip.driverPosition)
            return;


        $.ajax({
                url:app.apiurl + "/api/latest/c/drivers/",
                type:"get",
                data: {"latitude": position.lat(),"longitude": position.lng()},
                success: function(data) {
                                    console.log(data.drivers.length + " drivers found");
                                    for (var i = 0; i < data.drivers.length; i++) {
                                            var location = data.drivers[i];
                                            var icon = app.availableMarker;

                                            if(location.status != "available") {
                                                continue;
                                            }

                                            var marker = new google.maps.Marker({
                                                position: new google.maps.LatLng(location.latitude,location.longitude),
                                                map: app.map,
                                                icon: icon // This path is the custom pin to be shown. Remove this line and the proceeding comma to use default pin
                                            });
                                            app.driverMarkers.push(marker);
                                    }
                },
                error: function(jqXHR, textStatus, error){
                    app.showConnectionError(function(){fetchDriverLocations(position);});
                    console.log("error calling api to fetch driver locations");
                    console.log(jqXHR.status);
                    console.log(jqXHR.statusText);
                    console.log(jqXHR.responseText);
            }
        });
}


